// TestPBT_APMSUSPENDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestPBT_APMSUSPEND.h"
#include "TestPBT_APMSUSPENDDlg.h"

#include <PowrProf.h>
#pragma comment(lib, "PowrProf.lib")


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestPBT_APMSUSPENDDlg dialog




CTestPBT_APMSUSPENDDlg::CTestPBT_APMSUSPENDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestPBT_APMSUSPENDDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestPBT_APMSUSPENDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_MSGS, edtMsgs);
	DDX_Control(pDX, IDC_CHECK_FORCED, chkForced);
}

BEGIN_MESSAGE_MAP(CTestPBT_APMSUSPENDDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SLEEP, &CTestPBT_APMSUSPENDDlg::OnBnClickedButtonSleep)
	ON_MESSAGE(MY_MESSAGE_ID_POST_MSG, OnPostMessage2MsgWnd)
END_MESSAGE_MAP()


// CTestPBT_APMSUSPENDDlg message handlers

BOOL CTestPBT_APMSUSPENDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestPBT_APMSUSPENDDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestPBT_APMSUSPENDDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CTestPBT_APMSUSPENDDlg::_addMsgRAW(CString& strText)
{
	CString strMsg;
	edtMsgs.GetWindowText(strMsg);

	if(strMsg.GetLength() > 10000)
		strMsg.Left(10000);

	strText += strMsg;

	edtMsgs.SetWindowText(strText);

}

BOOL CTestPBT_APMSUSPENDDlg::AddLogMsg(LPCTSTR pText)
{
	BOOL bRes = FALSE;
	SYSTEMTIME st = {0};
	::GetLocalTime(&st);

	//Get main wnd
	if(theApp.m_pMainWnd)
	{
		static int nCnt = 0;

		CString strText;
		strText.Format(_T("%03d. %d/%d/%04d %02d:%02d:%02d.%03d: %s\r\n")
			,
			++nCnt,
			st.wMonth, st.wDay, st.wYear, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds,
			pText);

		//Is it the main thread?
		if(theApp.dwMainThreadId == ::GetCurrentThreadId())
		{
			//Same thread, post text
			((CTestPBT_APMSUSPENDDlg*)theApp.m_pMainWnd)->_addMsgRAW(strText);

			bRes = TRUE;
		}
		else
		{
			//Make a copy of the string
			TCHAR* pStrData = new TCHAR[strText.GetLength()];
			memcpy(pStrData, strText.GetString(), strText.GetLength() * sizeof(TCHAR));

			//Post message to the main thread to process it
			if(theApp.m_pMainWnd->PostMessage(MY_MESSAGE_ID_POST_MSG, (WPARAM)pStrData, strText.GetLength()))
			{
				bRes = TRUE;
			}
			else
			{
				//Failed
				MessageBeep(MB_ICONERROR);
				delete[] pStrData;
			}
		}
	}

	return bRes;
}

LRESULT CTestPBT_APMSUSPENDDlg::OnPostMessage2MsgWnd(WPARAM wParam, LPARAM lParam)
{
	//Request to post data from the worker thread
	const TCHAR* pStrData = (const TCHAR*)wParam;
	int nchLn = (int)lParam;

	if(pStrData)
	{
		//Make string
		CString str;
		memcpy(str.GetBufferSetLength(nchLn), pStrData, nchLn * sizeof(TCHAR));
		str.ReleaseBuffer();

		//Free mem
		delete[] pStrData;

		//Post message
		_addMsgRAW(str);

	}

	return 0;
}





void CTestPBT_APMSUSPENDDlg::OnBnClickedButtonSleep()
{
	// TODO: Add your control notification handler code here

	BOOL bForced = chkForced.GetCheck() == BST_CHECKED;

	VERIFY(AddLogMsg(_T("===============================")));
	VERIFY(AddLogMsg(EasyFormat(_T("Before creating the Sleep thread, forced=%d"), bForced)));

	DWORD dwThreadId;
	HANDLE hThreadSSR = ::CreateThread(NULL, 0, ThreadDelayedSetSuspendStateRunner, (LPVOID)bForced, 0, &dwThreadId);

	CString str;
	str.Format(_T("Result of starting the Sleep thread (hThread=0x%X)"), hThreadSSR);
	VERIFY(AddLogMsg(str));

	CloseHandle(hThreadSSR);

}

DWORD CTestPBT_APMSUSPENDDlg::ThreadDelayedSetSuspendStateRunner(LPVOID lpvParam)
{
	//Thread to call SetSuspendState for delayed operation
	BOOL bForced = lpvParam != 0;
	CString str;

	VERIFY(AddLogMsg(EasyFormat(_T("Before calling sleep API, forced=%d"), bForced)));

#ifdef _DEBUG
	BOOL bRes = 1;//SetSuspendState(FALSE, bForced, FALSE);		//We don't need to put our dev machine to sleep!
#else
	BOOL bRes = SetSuspendState(FALSE, bForced, FALSE);
#endif
	int nOSErr = ::GetLastError();

	str.Format(_T("Result of SetSuspendState(%s) API = %s, OSError = %d")
		, 
		bForced ? _T("Forced!") : _T("Non-forced"),
		bRes ? _T("SUCCESS") : _T("FAILURE"),
		nOSErr);
	VERIFY(AddLogMsg(str));

	return 0;
}


LRESULT CTestPBT_APMSUSPENDDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: Add your specialized code here and/or call the base class

	//Fuck MFC, let's get to the nitty gritty and see if we "REALLY" get this message???
	if(message == WM_POWERBROADCAST)
	{
		if(wParam == PBT_APMSUSPEND)
		{
			VERIFY(AddLogMsg(_T("SUSPEND event received")));
		}
		else if(wParam == PBT_APMRESUMEAUTOMATIC)
		{
			VERIFY(AddLogMsg(_T("RESUME event received")));
		}
	}
	

	return CDialog::WindowProc(message, wParam, lParam);
}
